unit SDL_image;

{ ---------------------------------------
    SDL_image:  An example image loading library for use with SDL
    Copyright (C) 1999, 2000, 2001  Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Sam Lantinga
    slouken@libsdl.org
----------------------------------------- }

{ -------------------------------
  Unit for FreePascal
  Rero2@fumi <rero2@yuumu.org>

  $Id: SDL_image.pp,v 1.1 2002/07/11 17:21:46 rero2 Exp $
-------------------------------- }

interface

  uses SDL_types, SDL__rwops, SDL_video;


    function IMG_LoadTyped_RW(src:pSDL_RWops; freesrc:Integer; ltype:PChar):PSDL_Surface; cdecl; external 'SDL_image';

    { --- Convenience functions }
    function IMG_Load(filename: PChar): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_Load_RW(src:PSDL_RWops; freesrc:Integer): PSDL_Surface; cdecl; external 'SDL_image';

    { ---
     Invert the alpha of a surface for use with OpenGL
     This function is now a no-op, and only provided for backwards compatibility.
    }
    function IMG_InvertAlpha(on: Integer): Integer; cdecl; external 'SDL_image';

    { --- Functions to detect a file type, given a seekable source }
    function IMG_isBMP(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isPNM(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isXPM(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isXCF(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isPCX(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isGIF(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isJPG(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isTIF(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isPNG(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';
    function IMG_isLBM(src:PSDL_RWops):Integer; cdecl; external 'SDL_image';

    { --- Individual loading functions }
    function IMG_LoadBMP_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadPNM_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadXPM_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadXCF_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadPCX_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadGIF_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadJPG_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadTIF_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadPNG_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadTGA_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';
    function IMG_LoadLBM_RW(src:pSDL_RWops): PSDL_Surface; cdecl; external 'SDL_image';

    function IMG_ReadXPMFromArray(xpm: ppchar): PSDL_Surface; cdecl; external 'SDL_image';

implementation


end.
