{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   debug.pp                                             }
{     ǥХåѥå롼                         }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: debug.pp,v 1.3 2002/07/11 17:21:47 rero2 Exp $ }
Unit  Debug;

{$MODE Delphi}


interface

Uses SDL, SDL_Types, SDL_Video, Grp_Screen;


Procedure  DebugInit(screen: TGameScreen;
                     Width:Integer; Height:Integer; Depth:Integer );
Procedure  DebugFree;
Procedure  DebugDisp(screen: TGameScreen);
Procedure  DebugPrint(mes: String);
Function   IntToStr(num: Integer): String;
Function   IntToHex(num, length: Integer): String;

Const
  { ----- åɽ }
  MessageMax = 50;
  { ----- ƥ㡼̾ }
  TextureName = 'ascii.bmp';
{$ifdef SDL_BYTEORDER = SDL_BIG_ENDIAN}
  Rmask = $ff000000;
  Gmask = $00ff0000;
  Bmask = $0000ff00;
  Amask = $000000ff;
{$else}
  Rmask = $000000ff;
  Gmask = $0000ff00;
  Bmask = $00ff0000;
  Amask = $ff000000;
{$endif}

Var
  { ----- ǥХå롼ͭݤ(ASCIIƤ뤫) }
  UseDebug: Boolean;
  { ----- եȥƥ㡼 }
  AsciiFont: PSDL_Surface;
  { ----- ץ졼 }
  AsciiPlane: PSDL_Surface;
  { ----- ɽʸ }
  StockString: Array[0..MessageMax] of String;
  StockNum: Integer;


implementation
{ -------------------------------------------------------------- }
{ --- ǥХåѥå롼                                 }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- åΥ饤ɽ    }
Procedure  print_msg(screen: TGameScreen; mes: String; disp_x, disp_y: Integer);
var
  i, l: Integer;
  c: Integer;
  rect1, rect2: SDL_Rect;
begin
  l := Length(mes);
  rect1.w := 8;
  rect1.h := 8;
  rect2.w := 8;
  rect2.h := 8;
  for i := 0 to l - 1 do
  begin
    c := Ord(mes[i + 1]);
    rect1.x := (c mod 16) * 8;
    rect1.y := (c div 16) * 8;
    rect2.x := disp_x;
    rect2.y := disp_y;
    SDL_BlitSurface(AsciiFont, @rect1, AsciiPlane, @rect2);
    disp_x := disp_x + 8;
  end;
end;



{ ---------------------------------------- }
{ --- ǥХåե               }
{ ---------------------------------------- }
Procedure  DebugInit(screen: TGameScreen;
                     Width:Integer; Height:Integer; Depth:Integer );
var
  plane: PSDL_Surface;
begin
  StockNum := 0;
  UseDebug := TRUE;
  plane := SDL_LoadBMP(PChar(TextureName));
  if plane = nil then
  begin
    UseDebug := FALSE;
    exit;
  end;
  AsciiFont := SDL_ConvertSurface(plane, screen.Screen.format, SDL_SWSURFACE);
  if AsciiFont = nil then  UseDebug := FALSE;
  SDL_SetColorKey(AsciiFont, SDL_SRCCOLORKEY, $007d00);
  AsciiPlane := SDL_CreateRGBSurface(SDL_SWSURFACE,
                                     Width, Height, Depth,
                                     rmask, gmask, bmask, amask);
  if AsciiPlane = nil then  UseDebug := FALSE;
  SDL_FreeSurface(plane);
end;


{ ---------------------------------------- }
{ --- ǥХåե                 }
{ ---------------------------------------- }
Procedure  DebugFree;
begin
  SDL_FreeSurface(AsciiPlane);
  SDL_FreeSurface(AsciiFont);
  UseDebug := FALSE;
end;


{ ---------------------------------------- }
{ --- ǥХåե           }
{ ---------------------------------------- }
Procedure  DebugDisp(screen: TGameScreen);
var
  disp_x, disp_y: Integer;
  disp_edge: Integer;
  rect1, rect2: SDL_Rect;
  i: Integer;
begin
  { --- Ƥʤä }
  if UseDebug = FALSE then Exit;

  { --- ɽ塼ѤޤƤʬɽ }
  disp_x := 0;
  disp_y := 0;
  disp_edge := 0;
  for i := 0 to StockNum - 1 do
  begin
    print_msg(screen, StockString[i], disp_x, disp_y);
    if disp_edge < (Length(StockString[i]) * 8) then
      disp_edge := Length(StockString[i]) * 8;
    disp_y := disp_y + 8;
  end;

  { --- ץ졼򥹥꡼ }
  if disp_edge > 0 then
  begin
//    SDL_UpdateRect(AsciiPlane, 0, 0, disp_edge, disp_y);
    rect1.x := 0;
    rect1.y := 0;
    rect1.w := disp_edge;
    rect1.h := disp_y;
    rect2.x := 0;
    rect2.y := 0;
    rect2.w := disp_edge;
    rect2.h := disp_y;
    SDL_BlitSurface(AsciiPlane, @rect1, screen.Screen, @rect2);
    SDL_FillRect(AsciiPlane, 0, $00000000);
  end;
  StockNum := 0;  
end;


{ ---------------------------------------- }
{ --- ǥХååΥ塼     }
{ ---------------------------------------- }
Procedure  DebugPrint(mes: String);
begin
  if StockNum < MessageMax then
  begin
    StockString[StockNum] := mes;
    StockNum := StockNum + 1;
  end;
end;


{ ---------------------------------------- }
{ --- ʸѴ                   }
{ ---------------------------------------- }
Function   IntToStr(num: Integer): String;
Var
  Ret: String;
begin
  Str(num, Ret);
  IntToStr := Ret;
end;


{ ---------------------------------------- }
{ --- 16ʿɽ                         }
{ ---------------------------------------- }
Function   IntToHex(num, length: Integer): String;
Const
  hexvalue: array[0..15] of Char = '0123456789ABCDEF';
Var
  i, d, l: Integer;
  Ret: String;
begin
  l := ((length - 1) * 4);
  d := $0f shl l;
  Ret := '';
  for i := 0 to (length - 1) do
  begin
    Ret := Ret + hexvalue[((num and d) shr l)];
    l := l - 4;
    d := d shr 4;
  end;
  IntToHex := Ret;
end;



end.