{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   grp_screen.pp                                        }
{     ̴饹                                     }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: grp_screen.pp,v 1.4 2002/08/08 04:31:15 rero2 Exp $ }
Unit Grp_Screen;

{$MODE Delphi}


interface

Uses classes, SDL, SDL_Types, SDL_Video, grp_texture, grp_sprite;

Const
  { --- 祹ץ饤ȿ }
  SPRITEMAX = 512;

Type
  TGameScreen = class(TObject)
    { ---  }
    private
    SDLScreen: PSDL_Surface;
    ScreenWidth: Integer;
    ScreenHeight: Integer;
    ScreenDepth: Integer;
    Sprites: Array [0..SPRITEMAX] of TGameSprite;
    TextureManage: TGameTexture;
    procedure Render(spr: TGameSprite);
    { --- ʬ }
    public
    constructor Create(Width:Integer; Height:Integer; Depth:Integer);
    destructor Destroy;
    procedure SetWMName(name: String);
    function GetSprite(id: Integer): TGameSprite;
    function GetTexture(id: Integer): PSDL_Surface;
    procedure DispScreen;
    procedure RefreshScreen;
    procedure LoadTexture(num: Integer; filename: String);
    procedure LoadTexturePure(num: Integer; filename: String);
    property Texture: TGameTexture read TextureManage;
    property Screen: PSDL_Surface read SDLScreen;
    property Width: Integer read ScreenWidth;
    property Height: Integer read ScreenHeight;
    property Depth: Integer read ScreenDepth;
  end;



implementation
{ -------------------------------------------------------------- }
{ --- ꡼饹                                       }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

constructor TGameScreen.Create(Width:Integer; Height:Integer; Depth:Integer);
var
  i: Integer;
begin
  { ----- ꡼ }
  SDLScreen := SDL_SetVideoMode(Width, Height, Depth, SDL_SWSURFACE);
  TextureManage := TGameTexture.Create;
  ScreenWidth := Width;
  ScreenHeight := Height;
  ScreenDepth := Depth;
  { ---  }
  for i := 0 to SPRITEMAX do
    Sprites[i] := nil;
end;

destructor TGameScreen.Destroy;
begin
  inherited;
  { ----- ƥβ }
  TextureManage.Free;
  { ----- ꡼β }
  SDL_FreeSurface(SDLScreen);
end;

{ ---------------------------------------- }
{ --- ɥȥ             }

procedure TGameScreen.SetWMName(name: String);
begin
  SDL_WM_SetCaption(PChar(name), PChar(name));
end;


{ ---------------------------------------- }
{ --- ե졼ॿߥ󥰤ˤ       }

procedure TGameScreen.DispScreen;
var
  i: Integer;
begin
  { --- ץ饤 }
  for i := 0 to SPRITEMAX do
    if Sprites[i] <> nil then
      Render(Sprites[i]);
end;


procedure TGameScreen.RefreshScreen;
begin
  { --- ꡼󥢥åץǡ }
  SDL_UpdateRect(Screen, 0, 0, 0, 0);
  { --- ꥢ }
//  SDL_FillRect(Screen, nil, $ff000040);
end;


{ ---------------------------------------- }
{ --- ץ饤ȤϤ                     }

function TGameScreen.GetSprite(id: Integer): TGameSprite;
begin
  GetSprite := nil;
  if id < 0 then Exit;
  if id > SPRITEMAX then Exit;
  if Sprites[id] = nil then
  begin
    Sprites[id] := TGameSprite.Create;
    Sprites[id].DispSw := False;
    Sprites[id].x := 0;
    Sprites[id].y := 0;
    Sprites[id].w := 0;
    Sprites[id].h := 0;
    Sprites[id].tx := 0;
    Sprites[id].ty := 0;
    Sprites[id].alpha := 0;
    GetSprite := Sprites[id];
  end
  else
    GetSprite := Sprites[id];
end;


{ ---------------------------------------- }
{ --- ƥϤ                     }

function TGameScreen.GetTexture(id: Integer): PSDL_Surface;
begin
  GetTexture := TextureManage.GetTexture(id);
end;


{ ---------------------------------------- }
{ --- ƥɤ               }

procedure TGameScreen.LoadTexture(num: Integer; filename: String);
begin
  TextureManage.Load(num, filename, Screen, True);
end;

procedure TGameScreen.LoadTexturePure(num: Integer; filename: String);
begin
  TextureManage.Load(num, filename, Screen, False);
end;


{ ---------------------------------------- }
{ --- ץ饤Ȥɽ(ž)           }
procedure TGameScreen.Render(spr: TGameSprite);
var
  org_alpha: Uint8;
  rect1, rect2: SDL_Rect;
begin
    { --- ɽå }
    if spr.DispSw = FALSE then Exit;
    if spr.Texture = nil then Exit;
    { --- ɽϰ }
    rect1.w := spr.w;
    rect1.h := spr.h;
    rect2.w := spr.w;
    rect2.h := spr.h;
    rect1.x := spr.tx;
    rect1.y := spr.ty;
    rect2.x := spr.x;
    rect2.y := spr.y;
    org_alpha := spr.Texture.format.alpha;
    if org_alpha <> spr.alpha then
    begin
      if spr.alpha < 255 then
        SDL_SetAlpha(spr.Texture, SDL_SRCALPHA, spr.alpha)
      else
        SDL_SetAlpha(spr.Texture, 0, 0)
    end;
    SDL_BlitSurface(spr.Texture, @rect1, Screen, @rect2);
    if org_alpha <> spr.alpha then
      SDL_SetAlpha(spr.Texture, SDL_SRCALPHA, org_alpha);
end;



end.
