{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   input.pp                                             }
{     ɤߤȤʬ                               }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: input.pp,v 1.5 2002/08/08 04:31:15 rero2 Exp $ }
Unit  Input;

{$MODE Delphi}


interface

Uses SDL, SDL_Types, SDL_Events, SDL_keyboard;


procedure  InputInit;
procedure  InputFree;
procedure  InputPoll;
function  InputExit: Boolean;
function  InputJoyKey(side: Integer): Integer;
function  InputJoyKeyTriger(side: Integer): Integer;

Const
  IN_Up = $0001;
  IN_Down = $0002;
  IN_Left = $0004;
  IN_Right = $0008;
  IN_Button1 = $0010;
  IN_Button2 = $0020;
  IN_Button3 = $0040;
  IN_Button4 = $0080;

Var
  { ----- ٥ }
  event: SDL_Event;
{$if 0}
  { ----- ³Ƥ른祤ƥåο }
  JoyNum: Integer;
  JoyPtr: Array [0..1] of PSDL_Joystick;
{$endif}
  { ----- 桼Υ }
  JoyKey: Array [0..1] of Cardinal;
  JoyKeyPast: Array [0..1] of Cardinal;
  { ----- λե饰 }
  AppExit: Boolean;


implementation
{ -------------------------------------------------------------- }
{ --- ȥ祤ƥåɤߤȤ                           }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- Ƚ̽                       }
{ ---------------------------------------- }
procedure  key_read_down(key: SDL_KeyboardEvent);
begin
  if key.keysym.sym = SDLK_UP then	
    JoyKey[0] := JoyKey[0] or IN_Up;
  if key.keysym.sym = SDLK_Down then	
    JoyKey[0] := JoyKey[0] or IN_Down;
  if key.keysym.sym = SDLK_LEFT then	
    JoyKey[0] := JoyKey[0] or IN_Left;
  if key.keysym.sym = SDLK_RIGHT then	
    JoyKey[0] := JoyKey[0] or IN_Right;
  if key.keysym.sym = SDLK_Z then	
    JoyKey[0] := JoyKey[0] or IN_Button1;
  if key.keysym.sym = SDLK_X then	
    JoyKey[0] := JoyKey[0] or IN_Button2;
  if key.keysym.sym = SDLK_C then	
    JoyKey[0] := JoyKey[0] or IN_Button3;
  if key.keysym.sym = SDLK_V then	
    JoyKey[0] := JoyKey[0] or IN_Button4;
  if key.keysym.sym = SDLK_SPACE then	
    JoyKey[0] := JoyKey[0] or IN_Button1;

  if key.keysym.sym = SDLK_Q then	
    AppExit := True;
  if key.keysym.sym = SDLK_ESCAPE then	
    AppExit := True;
end;

procedure  key_read_up(key: SDL_KeyboardEvent);
begin
  if key.keysym.sym = SDLK_UP then	
    JoyKey[0] := JoyKey[0] and (not(IN_Up));
  if key.keysym.sym = SDLK_Down then	
    JoyKey[0] := JoyKey[0] and (not(IN_Down));
  if key.keysym.sym = SDLK_LEFT then	
    JoyKey[0] := JoyKey[0] and (not(IN_Left));
  if key.keysym.sym = SDLK_RIGHT then	
    JoyKey[0] := JoyKey[0] and (not(IN_Right));
  if key.keysym.sym = SDLK_Z then	
    JoyKey[0] := JoyKey[0] and (not(IN_Button1));
  if key.keysym.sym = SDLK_X then	
    JoyKey[0] := JoyKey[0] and (not(IN_Button2));
  if key.keysym.sym = SDLK_C then	
    JoyKey[0] := JoyKey[0] and (not(IN_Button3));
  if key.keysym.sym = SDLK_V then	
    JoyKey[0] := JoyKey[0] and (not(IN_Button4));
  if key.keysym.sym = SDLK_SPACE then	
    JoyKey[0] := JoyKey[0] and (not(IN_Button1));
end;



{ ---------------------------------------- }
{ --- ֤ν                   }
{ ---------------------------------------- }
procedure  InputInit;
var
  i: Integer;
begin
{$if 0}
  JoyPtr[0] = nil;
  JoyPtr[1] = nil;
  { ----- 祤ƥå¸߳ǧ }
  JoyNum := SDL_NumJoysticks;
  for i := 0 to (JoyNum + 1) do
  begin
   JoyPtr[i] := SDL_JoystickOpen(i);
  end;
{$endif}
end;


{ ---------------------------------------- }
{ --- ֤β                       }
{ ---------------------------------------- }
procedure  InputFree;
var
  i: Integer;
begin
{$if 0}
  { ----- 祤ƥåβ }
  for i := 0 to (JoyNum + 1) do
  begin
   SDL_JoystickClose(JoyPtr[i]);
  end;
{$endif}
end;



{ ---------------------------------------- }
{ --- ŪɤߤȤ                 }
{ ---------------------------------------- }
procedure  InputPoll;
begin
  AppExit := False;
  { ----- for Triger }
  JoyKeyPast[0] := JoyKey[0];
  JoyKeyPast[1] := JoyKey[1];
  { ----- Key Event Read }
  while SDL_PollEvent(@event) <> 0 do
  begin
    case event.eventtype of
      SDL_KEYUP:
        key_read_up(event.key);
      SDL_KEYDOWN:
        key_read_down(event.key);
      SDL_EVENTQUIT:
        AppExit := True;
    end;
  end;
end;


{ ---------------------------------------- }
{ --- ץꥱλȽ       }
{ ---------------------------------------- }
function  InputExit: Boolean;
begin
  InputExit := AppExit;  
end;


{ ---------------------------------------- }
{ --- 桼ϤɤߤȤ               }
{ ---------------------------------------- }
function  InputJoyKey(side: Integer): Integer;
var
  R: Integer;
begin
  r := 0;
  if (side = 0) or (side = 1) then
  begin
    r := JoyKey[side];
  end;
  InputJoyKey := r;
end;


{ ---------------------------------------- }
{ --- 桼ϤΥȥꥬɤߤȤ       }
{ ---------------------------------------- }
function  InputJoyKeyTriger(side: Integer): Integer;
var
  R: Integer;
begin
  r := 0;
  if (side = 0) or (side = 1) then
  begin
    r := (JoyKey[side] xor JoyKeyPast[side]) and JoyKey[side];
  end;
  InputJoyKeyTriger := r;
end;


end.