{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   puz_base.pp                                          }
{     ѥ륲 base 饹                           }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: puz_base.pp,v 1.6 2002/08/25 09:41:12 rero2 Exp $ }
Unit Puz_Base;

{$MODE Delphi}



interface

Uses classes, Debug;

Const
  { --- ֥å }
  BLOCK_WIDTH = 24;
  BLOCK_HEIGHT = 24;
  { --- եɥ }
  FIELD_WIDTH = 8;
  FIELD_HEIGHT = 13;  { Next  }
  ALL_BLOCK = FIELD_WIDTH * FIELD_HEIGHT;
  { --- ĤǾä뤫 }
  LINE_LENGTH = 4;

Type
  GamePhase = (
    STEP_PAUSE,
    STEP_NORMAL,
    STEP_SWAP,
    STEP_LINECHECK,
    STEP_LINEFLASH,
    STEP_LINEERASE,
    STEP_DROPCHECK,
    STEP_DROPWORK,
    STEP_END);
  MoveDir = (
    MOVE_UP,
    MOVE_DOWN,
    MOVE_LEFT,
    MOVE_RIGHT);
  SwapFlag = (SWAP_NONE,
              SWAP_MASTER,
              SWAP_SLAVE);
  { ----- ֥åݻ쥳 }
  PBlock = ^Block;
  Block = record
    { --- ֥åμ(0¸ߤ) }
    Color: Integer;
    { --- ·ȽԤݤΥե饰 }
    LineCheck: Boolean;
    { --- ·ä֥åǤե饰 }
    LineBlock: Boolean;
    { --- ·äƤtimer }
    LineTimer: Integer;
    { --- 夲timer }
    PopupTimer: Integer;
    { --- 夲֥եå}
    PopupOffset: Integer;
    { --- ֥åǤ뤳ȤΥե饰 }
    DropCheck: Boolean;
    { --- 륢˥᡼timer }
    DropTimer: Integer;
    { --- 륢˥᡼Υեå }
    DropOffset: Integer;
    { --- ؤե饰(ؤɤ) }
    SwapSide: SwapFlag;
    { --- ؤtimer }
    SwapTimer: Integer;
    { --- ؤ֥եå }
    SwapOffsetX: Integer;
    SwapOffsetY: Integer;
  end;
  { ----- 桼Ͼݻ쥳 }
  PCursor = ^Cursor;
  Cursor = record
    { --- ֥åɸŪ }
    X: Integer;
    Y: Integer;
    { --- ֥åĤǤ뤫ݤ }
    HaveBlock: Boolean;
    { --- ؤtimer }
    SwapTimer: Integer;
    { --- ؤ֥եå }
    SwapOffsetX: Integer;
    SwapOffsetY: Integer;
    { --- ֥å夬ɿ }
    PopupTimer: Integer;
    PopupOffset: Integer;
  end;


  { ------------------------------------- }
  { ----- ѥܥ饹 }
  TPuzzleBase = class(TObject)
    { --------------------------- }
    { --- 饹ѿ }
    protected
    GameTimer: Integer;
    { --- 饹 }
    { - ॹƥå }
    GameStep: GamePhase;
    { - ץ쥤䡼 }
    UA: Cursor;
    { - ֥åξ }
    Item: array [0..(FIELD_WIDTH * FIELD_HEIGHT)] of Block;
    { - եɤξ }
    Field: array [0..(FIELD_WIDTH * FIELD_HEIGHT)] of PBlock;
    { - ֥å顼(鿧Ƭ) }
    BlockColor: array [0..6] of Integer;
    { - ֥å顼 }
    ColorNum: Integer;
    { - ͥȤޤǤΥ }
    NextInterval: Integer;
    { - ͥȤtimer }
    NextTimer: Integer;
    { - ٥ }
    Level: Integer;
    { - 饯顼(֥åο˱ƶ) }
    CharaColor: Integer;
    { - ˥᡼ե饰(ΤưߤޤäƤfalse) }
    Animation: Boolean;
    { - ֥åä }
    EraseBlock: Integer;
    { - ä֥åˤ }
    EraseScore: Integer;
    { -  }
    Score: Integer;
    { - Ϣ }
    Combo: Integer;
    { - ४Сե饰 }
    GameOver: Boolean;
    { --------------------------- }
    { ---  }
    private
    procedure SetBlock;
    function GetBlock: PBlock;
    function GetBlockColor: Integer;
    procedure PopupNext;
    function PopupWork: Boolean;
    function FieldHeight: Integer;
    function MoveWork: Boolean;
    function DropRequest: Boolean;
    function DropWork: Boolean;
    function LineCheck: Integer;
    function LineWork: Boolean;
    function LineCount(x, y, dx, dy: Integer; layer: Integer): Integer;
    { ------------------- }
    { --- ʬ }
    public
    constructor Create;
    destructor Destroy; virtual;
    procedure GameInit(col: Integer);
    procedure GameExec;
    procedure GamePause(mode: GamePhase);
    procedure GameLevel(lset: Integer);
    function LevelCheck: Boolean;
    function MoveRequest(posx, posy: Integer; dir: MoveDir): Boolean;
  end;



implementation

Uses  sound;

Const
  SwapTable: Array [0..4] of Integer = (0, 6, 4, 0, 0);
  BlockColorSet: Array [0..6] of Integer = (0, 5, 1, 3, 4, 2, 6);
  { ---  }
  LevelColor: Array [0..29] of Integer = (3, 3, 3, 3, 3, 3, 3, 4, 4, 4,
                                          4, 4, 4, 4, 4, 4, 4, 4, 5, 5,
                                          5, 5, 5, 5, 5, 6, 6, 6, 7, 7);
  LevelSpeed: Array [0..29] of Integer = (200, 140, 120, 120, 120,
                                          100, 100, 160, 160, 140,
                                          140, 140, 120, 120, 120,
                                          100, 100, 140, 120, 100,
                                          100, 100, 100,  80, 120,
                                          120, 120, 100, 100,  80);
  LevelBlock: Array [0..29] of Integer = (   0,  30,  60, 100, 150,
                                           200, 250, 300, 350, 400,
                                           500, 550, 600, 650, 700,
                                           900, 950,1000,1050,1100,
                                          1300,1350,1400,1450,1500,
                                          2000,2050,2100,2200,2500);

Var
  watch: Integer;

{ -------------------------------------------------------------- }
{ --- ѥեɴ饹                                 }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

constructor TPuzzleBase.Create;
var
  i: Integer;
begin
  { --- ե󥯥ꥢ }
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) do
    Field[i] := nil;
end;

destructor TPuzzleBase.Destroy;
begin
  inherited;
end;


{ ---------------------------------------------------- }
{ --- ѥ                                 --- }
{ ---------------------------------------------------- }

procedure TPuzzleBase.GameInit(col: Integer);
var
  i, t : Integer;
begin
  { --- ե󥯥ꥢ }
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) do
    Field[i] := nil;
  { --- ֥å }
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) do
  begin
    Item[i].Color := 0;
    Item[i].LineCheck := False;
    Item[i].LineBlock := False;
    Item[i].LineTimer := 0;
    Item[i].PopupTimer := 0;
    Item[i].PopupOffset := 0;
    Item[i].DropCheck := False;
    Item[i].DropTimer := 0;
    Item[i].DropOffset := 0;
    Item[i].SwapSide := SWAP_NONE;
    Item[i].SwapTimer := 0;
    Item[i].SwapOffsetX := 0;
    Item[i].SwapOffsetY := 0;
  end;
  { --- Ūʥ }
  GameStep := STEP_PAUSE;
  Animation := False;
  CharaColor := col;
  Level := 1;
  ColorNum := 3;
  NextInterval := 150;
  NextTimer := 0;
  EraseBlock := 0;
  EraseScore := 0;
  Score := 0;
  Combo := 1;
  GameOver := False;
  GameLevel(Level);
  { --- ֥å顼 }
  for i := 0 to 6 do
    BlockColor[i] := BlockColorSet[i];
//  t := BlockColor[col - 1];
//  BlockColor[col - 1] := BlockColor[0];
//  BlockColor[0] := t;
  { --- ֥å }
  SetBlock;
  { ---  }
  ua.X := 4;
  ua.Y := 2;
  ua.SwapTimer := 0;
  ua.SwapOffsetX := 0;
  ua.SwapOffsetY := 0;
end;


{ ---------------------------------------------------- }
{ --- ѥ륲ǡ١ᥤ               --- }
{ ---------------------------------------------------- }
procedure TPuzzleBase.GameExec;
begin
  DebugPrint('Next: '+IntToStr(NextTimer));
  DebugPrint('Line: '+IntToStr(watch));

  case GameStep of
    STEP_PAUSE:
      begin
        NextTimer := NextInterval;
      end;

    STEP_NORMAL:
      begin
        Animation := False;
        Combo := 1;
        if PopupWork = True then GameStep := STEP_LINECHECK;
      end;

    STEP_SWAP:
      begin
        PopupWork;
        if MoveWork = False then
        begin
          if DropRequest = True then
            GameStep := STEP_DROPWORK
          else
          begin
            watch := LineCheck;
            if watch > 0 then
            begin
              EraseBlock := EraseBlock + watch; 
              EraseScore := ((watch - 3) * 10 * Combo) * 4;
              Score := Score + EraseScore;
              Animation := True;
              SoundSE(5);
              GameStep := STEP_LINEFLASH;
            end
            else
              GameStep := STEP_DROPCHECK;
          end;
        end;
      end;

    STEP_DROPCHECK:
      begin
        if DropRequest = True then
          GameStep := STEP_DROPWORK
        else
          GameStep := STEP_LINECHECK;
      end;

    STEP_DROPWORK:
      begin
        Animation := True;
        PopupWork;
        if DropWork = False then
          GameStep := STEP_LINECHECK;
      end;

    STEP_LINECHECK:
      begin
        watch := LineCheck;
        if watch > 0 then
        begin
          SoundSE(5);
          EraseBlock := EraseBlock + watch; 
          EraseScore := ((watch - 3) * 10 * Combo) * 4;
          Score := Score + EraseScore;
          GameStep := STEP_LINEFLASH;
        end
        else
          GameStep := STEP_NORMAL;
      end;

    STEP_LINEFLASH:
      begin
        Animation := True;
        PopupWork;
        if LineWork = False then
        begin
          Combo := Combo + 1;
          GameStep := STEP_DROPCHECK;
        end;
      end;

    STEP_END: ;
  end;
end;


{ ---------------------------------------------------- }
{ --- ॹƥåפλ(Ϥߤ)           --- }
{ ---------------------------------------------------- }

procedure TPuzzleBase.GamePause(mode: GamePhase);
begin
  GameStep := mode;
end;


{ ---------------------------------------------------- }
{ --- ٥                           --- }
{ ---------------------------------------------------- }

procedure TPuzzleBase.GameLevel(lset: Integer);
var
  l: Integer;
begin
  { -- ٥˹碌 }
  l := lset - 1;
  if l < 0 then l := 0;
  if l > 29 then l := 29;
  { ѲΤϤ }
  ColorNum := LevelColor[l];
  NextInterval := LevelSpeed[l];
end;


{ ---------------------------------------------------- }
{ --- ߤΥ٥                           --- }
{ ---------------------------------------------------- }

function TPuzzleBase.LevelCheck: Boolean;
var
  i, lv: Integer;
begin
  LevelCheck := False;
  lv := 0;
  for i := 0 to 29 do
  begin
    if LevelBlock[i] < EraseBlock then lv := i;
  end;
  if lv = Level then
  begin
    Level := level + 1; 
    LevelCheck := True;
  end;
end;

{ ---------------------------------------------------- }
{ --- ֥åѥ                         --- }
{ ---------------------------------------------------- }

procedure TPuzzleBase.SetBlock;
var
  i: Integer;
begin
  { --- ե󥯥ꥢ }
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) do
    Field[i] := nil;
  { --- Ȼ˿·äƤʤ褦 }
  { == 괺 (^^; }
  for i := 0 to (FIELD_WIDTH * 4) - 1 do
  begin
    Field[i] := GetBlock;
    Field[i].Color := GetBlockColor + 1;
    Field[i].LineCheck := True;
    Field[i].LineBlock := False;
  end;
end;

{ ------------------------------------ }
{ --- Ƥ֥å֤  }
function TPuzzleBase.GetBlock: PBlock;
var
  b: PBlock;
  i: Integer;
begin
  b := nil;
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) do
  begin
    if Item[i].Color = 0 then
    begin
      b := @Item[i];
      break;
    end;
  end;
  GetBlock := b;
end;


{ ------------------------------------ }
{ --- ٤ФŬڤʥ֥å顼  }
function TPuzzleBase.GetBlockColor: Integer;
var
  c: Integer;
begin
  { - ֥å顼ϥ }
  { === ƥຮĴʤ }
  c := Random(ColorNum);
  { -  }
  GetBlockColor := BlockColor[c];
end;


{ ---------------------------------------------------- }
{ --- ͥȥ֥å夬ȼ         --- }
{ ---------------------------------------------------- }

procedure TPuzzleBase.PopupNext;
var
  i: Integer;
  pos: Integer;
begin
  { --- ե֥åλ夲 }
  for i := 0 to (FIELD_WIDTH * (FIELD_HEIGHT - 1)) - 1 do
  begin
    pos := FIELD_WIDTH * FIELD_HEIGHT - 1 - i;
    Field[pos] := Field[pos - FIELD_WIDTH];
    if Field[pos] <> nil then
    begin
      Field[pos].PopupTimer := 4;
      Field[pos].PopupOffset := 24;
    end;
  end;
  { --- ͥȥ֥åν }
  for i := 0 to FIELD_WIDTH - 1 do
  begin
    Field[i] := nil;
    Field[i] := GetBlock;
    Field[i].Color := GetBlockColor + 1;
    Field[i].PopupTimer := 4;
    Field[i].PopupOffset := BLOCK_HEIGHT;
    Field[i].LineCheck := True;
  end;
  { --- ĤߥǤä饫ư }
  if ua.HaveBlock = True then
  begin
    ua.y := ua.y + 1;
    ua.PopupTimer := 4;
    ua.PopupOffset := BLOCK_HEIGHT;
  end;
end;


{ ---------------------------------------------------- }
{ --- ͥȤ夬ꥫȤȥեå     --- }
{ ---------------------------------------------------- }

function TPuzzleBase.PopupWork: Boolean;
var
  r: Boolean;
  i: Integer;
begin
  r := False;
  { --- 夬ꥪեå }
  for i := 0 to ALL_BLOCK - 1 do
  begin
    if Item[i].Color <> 0 then
    begin
      if Item[i].PopupTimer > 0 then
      begin
        Item[i].PopupTimer := Item[i].PopupTimer - 1;
        Item[i].PopupOffset := Item[i].PopupOffset - 6;
        if (Item[i].PopupOffset < 0) or (Item[i].PopupTimer = 0) then
          Item[i].PopupOffset := 0;
          r := True;
      end;
    end;
  end;
  if ua.PopupTimer > 0 then
  begin
    ua.PopupTimer := ua.PopupTimer - 1;
    ua.PopupOffset := ua.PopupOffset - 6;
    if (ua.PopupOffset < 0) or (ua.PopupTimer = 0) then
      ua.PopupOffset := 0;
  end;
  { --- ͥ夬ޤǤtimer }
  if NextTimer > 0 then
    NextTimer := NextTimer - 1;
  if (NextTimer = 0) and (GameStep = STEP_NORMAL) then
  begin
    NextTimer := NextInterval;
    { -- ४СȽ }
    if Fieldheight = 0 then
      GameOver := True
    else
    begin
      { -- ͥ夬 }
      PopupNext;
    end;
  end;
  { -- SE }
  if NextTimer = 10 then
    SoundSE(8);
  { --- ꤢ꽪λ }
  PopupWork := r;
end;


{ ---------------------------------------------------- }
{ --- եκǹ̥֥åΰ֤֤     --- }
{ ---------------------------------------------------- }

function TPuzzleBase.FieldHeight: Integer;
var
  i, j, r, pos: Integer;
  hit: Boolean;
begin
  for i := 0 to FIELD_HEIGHT - 1 do
  begin
    hit := false;
    for j := 0 to FIELD_WIDTH - 1 do
    begin
      if Field[(((FIELD_HEIGHT - 1) - i) * FIELD_WIDTH) + j] <> nil then
        hit := true;
    end;
    if hit = true then
    begin
      r := i;
      break;
    end;
  end;
  { -  }
  FieldHeight := r;
end;


{ ---------------------------------------------------- }
{ --- ֥åΰؤꥯȤ       --- }
{ ---------------------------------------------------- }

function TPuzzleBase.MoveRequest(posx, posy: Integer; dir: MoveDir): Boolean;
var
  master, target: PBlock;
begin
  { --- ֤˥֥å̵ʤ饹å }
  if Field[posx + (posy * FIELD_WIDTH)] = nil then
  begin
    MoveRequest := False;
    Exit;
  end;
  { --- ذư褦ȤƤ饨顼 }
  if (posx = 0) and (dir = MOVE_LEFT) then
  begin
    MoveRequest := False;
    Exit;
  end;
  if (posx = (FIELD_WIDTH - 1)) and (dir = MOVE_RIGHT) then
  begin
    MoveRequest := False;
    Exit;
  end;
  if (posy = 1) and (dir = MOVE_DOWN) then
  begin
    MoveRequest := False;
    Exit;
  end;
  if (posy = (FIELD_HEIGHT - 1)) and (dir = MOVE_UP) then
  begin
    MoveRequest := False;
    Exit;
  end;
  if (Field[posx + ((posy - 1) * FIELD_WIDTH)] = nil) and (dir = MOVE_UP) then
  begin
    MoveRequest := False;
    Exit;
  end;
  { ---------------------------------------------- }
  { --- ưꥯ  }
  if dir = MOVE_UP then
  begin
    master := Field[posx + (posy * FIELD_WIDTH)];
    target := Field[posx + ((posy + 1) * FIELD_WIDTH)];
    if target <> nil  then
    begin
      Field[posx + ((posy + 1) * FIELD_WIDTH)] := master;
      Field[posx + (posy * FIELD_WIDTH)] := target;
      master.SwapSide := SWAP_MASTER;
      master.SwapTimer := 3;
      master.SwapOffsetX := 0;
      master.SwapOffsetY := -BLOCK_HEIGHT;
      master.LineCheck := True;
      if target <> nil then
      begin
        target.SwapSide := SWAP_SLAVE;
        target.SwapTimer := 3;
        target.SwapOffsetX := 0;
        target.SwapOffsetY := -BLOCK_HEIGHT;
        target.LineCheck := True;
      end;
      ua.SwapTimer := 3;
      ua.SwapOffsetX := 0;
      ua.SwapOffsetY := BLOCK_HEIGHT;
    end;
  end;
  if dir = MOVE_DOWN then
  begin
    master := Field[posx + (posy * FIELD_WIDTH)];
    target := Field[posx + ((posy - 1) * FIELD_WIDTH)];
    Field[posx + ((posy - 1) * FIELD_WIDTH)] := master;
    Field[posx + (posy * FIELD_WIDTH)] := target;
    master.SwapSide := SWAP_MASTER;
    master.SwapTimer := 3;
    master.SwapOffsetX := 0;
    master.SwapOffsetY := -BLOCK_HEIGHT;
    master.LineCheck := True;
    if target <> nil then
    begin
      target.SwapSide := SWAP_SLAVE;
      target.SwapTimer := 3;
      target.SwapOffsetX := 0;
      target.SwapOffsetY := BLOCK_HEIGHT;
      target.LineCheck := True;
    end;
    ua.SwapTimer := 3;
    ua.SwapOffsetX := 0;
    ua.SwapOffsetY := -BLOCK_HEIGHT;
  end;
  if dir = MOVE_LEFT then
  begin
    master := Field[posx + (posy * FIELD_WIDTH)];
    target := Field[posx - 1 + (posy * FIELD_WIDTH)];
    Field[posx - 1 + (posy * FIELD_WIDTH)] := master;
    Field[posx + (posy * FIELD_WIDTH)] := target;
    master.SwapSide := SWAP_MASTER;
    master.SwapTimer := 3;
    master.SwapOffsetX := BLOCK_WIDTH;
    master.SwapOffsetY := 0;
    master.LineCheck := True;
    if target <> nil then
    begin
      target.SwapSide := SWAP_SLAVE;
      target.SwapTimer := 3;
      target.SwapOffsetX := -BLOCK_WIDTH;
      target.SwapOffsetY := 0;
      target.LineCheck := True;
    end;
    ua.SwapTimer := 3;
    ua.SwapOffsetX := BLOCK_WIDTH;
    ua.SwapOffsetY := 0;
  end;
  if dir = MOVE_RIGHT then
  begin
    master := Field[posx + (posy * FIELD_WIDTH)];
    target := Field[posx + 1 + (posy * FIELD_WIDTH)];
    Field[posx + 1 + (posy * FIELD_WIDTH)] := master;
    Field[posx + (posy * FIELD_WIDTH)] := target;
    master.SwapSide := SWAP_MASTER;
    master.SwapTimer := 3;
    master.SwapOffsetX := -BLOCK_WIDTH;
    master.SwapOffsetY := 0;
    master.LineCheck := True;
    if target <> nil then
    begin
      target.SwapSide := SWAP_SLAVE;
      target.SwapTimer := 3;
      target.SwapOffsetX := BLOCK_WIDTH;
      target.SwapOffsetY := 0;
      target.LineCheck := True;
    end;
    ua.SwapTimer := 3;
    ua.SwapOffsetX := -BLOCK_WIDTH;
    ua.SwapOffsetY := 0;
  end;

  { - ưλ }
  MoveRequest := True;
  GameStep := STEP_SWAP;
end;


{ ---------------------------------------------------- }
{ --- ؤ˥᡼»                   --- }
{ ---------------------------------------------------- }

function TPuzzleBase.MoveWork: Boolean;
var
  i: Integer;
  working: Boolean;
begin
  working := False;
  { --- ե֥åΰư }
  for i := FIELD_WIDTH to (FIELD_WIDTH * FIELD_HEIGHT) - 1 do
  begin
    if Field[i] <> nil then
    begin
      if Field[i].SwapTimer > 0 then
      begin
        Field[i].SwapTimer := Field[i].SwapTimer - 1;
        if Field[i].SwapTimer = 0 then
        begin
          Field[i].SwapSide := SWAP_NONE;
          Field[i].SwapOffsetX := 0;
          Field[i].SwapOffsetY := 0;
        end
        else
        begin
          Field[i].SwapOffsetX := Field[i].SwapOffsetX div 2;
          Field[i].SwapOffsetY := (Field[i].SwapOffsetY div 2);
          if Field[i].SwapSide = SWAP_SLAVE then
            Field[i].SwapOffsetY := Field[i].SwapOffsetY + SwapTable[Field[i].SwapTimer];
           working := True;
        end;
      end;
    end;
  end;
  { --- ΰư }
  if ua.SwapTimer > 0 then
  begin
    ua.SwapTimer := ua.SwapTimer - 1;
    if ua.SwapTimer = 0 then
    begin
      ua.SwapOffsetX := 0;
      ua.SwapOffsetY := 0;
    end
    else
    begin
      ua.SwapOffsetX := ua.SwapOffsetX div 2;
      ua.SwapOffsetY := ua.SwapOffsetY div 2;
    end;
  end;
  { - ޤ }
  MoveWork := working;
end;


{ ---------------------------------------------------- }
{ --- ֥åȽꥯ           --- }
{ ---------------------------------------------------- }

function TPuzzleBase.DropRequest: Boolean;
var
  i: Integer;
  position, t: Integer;
  working: Boolean;
  b: PBlock;
begin
  working := False;
  for i := FIELD_WIDTH to (FIELD_WIDTH * FIELD_HEIGHT) - 1 do
  begin
    if Field[i] <> nil then
    begin
      if Field[i - FIELD_WIDTH] = nil then
      begin
        working := True;
        { -- ̵ΤǤɤޤ뤫 }
        position := i - FIELD_WIDTH;
        t := 0;
	repeat
          if Field[position] <> nil then break;
          position := position - FIELD_WIDTH;
          t := t + 1;
        until(position < FIELD_WIDTH);
        { --  }
        position := position + FIELD_WIDTH;
	b := Field[i];
	b.LineCheck := True;
	b.DropCheck := True;
	b.DropTimer := 2 * t;
	b.DropOffset := 24 * t;
        Field[position] := b;
        Field[i] := nil;
      end;
    end;
  end;
  DropRequest := working;
end;


{ ---------------------------------------------------- }
{ --- ֥å                               --- }
{ ---------------------------------------------------- }

function TPuzzleBase.DropWork: Boolean;
var
  i: Integer;
  working: Boolean;
begin
  working := False;
  for i := FIELD_WIDTH to (FIELD_WIDTH * FIELD_HEIGHT) - 1 do
  begin
    if Field[i] <> nil then
    begin
      if Field[i].DropTimer > 0 then
      begin
        working := True;
        Field[i].DropTimer := Field[i].DropTimer - 1;
        if Field[i].DropTimer = 0 then
        begin
          Field[i].DropOffset := 0;
        end
        else
        begin
          Field[i].DropOffset := Field[i].DropOffset - 12;
        end;
      end;
    end;
  end;
  { - ޤ }
  DropWork := working;
end;


{ ---------------------------------------------------- }
{ --- ֥å·Υå                       --- }
{ ---------------------------------------------------- }

function TPuzzleBase.LineCheck: Integer;
var
  i, j: Integer;
  working: Integer;
  line: Integer;
begin
  working := 0;
  for j := 1 to (FIELD_HEIGHT - 1) do
  begin
    for i := 0 to (FIELD_WIDTH -1) do
    begin
      if Field[(j * FIELD_WIDTH) + i] <> nil then
      begin
        if Field[(j * FIELD_WIDTH) + i].LineCheck = True then
        begin
          Field[(j * FIELD_WIDTH) + i].LineCheck := False;
          working := working + LineCount(i, j, 1, 0, 0);
//          working := working + LineCount(i, j, -1,  0, 0);
          working := working + LineCount(i, j,  0,  1, 0);
//          working := working + LineCount(i, j,  0, -1, 0);
        end;
      end;
    end;
  end;
  { --- ޤ }
  LineCheck := working;
end;


{ ---------------------------------------------------- }
{ --- ֥å·äƾä륨ե             --- }
{ ---------------------------------------------------- }

function TPuzzleBase.LineWork: Boolean;
var
  i: Integer;
  working: Boolean;
  sound: Boolean;
begin
  working := False;
  sound := False;
  for i := FIELD_WIDTH to (FIELD_WIDTH * FIELD_HEIGHT) - 1 do
  begin
    if Field[i] <> nil then
    begin
      if Field[i].LineTimer > 0 then
      begin
        if Field[i].LineTimer = 10 then
          sound := True;
        working := True;
        Field[i].LineTimer := Field[i].LineTimer - 1;
        if Field[i].LineTimer = 0 then
        begin
          Field[i].Color := 0;
          Field[i].LineBlock := False;
          Field[i].LineCheck := False;
          Field[i] := Nil;
        end;
      end;
    end;
  end;
  if sound = true then SoundSE(6);
  { - ޤ }
  LineWork := working;
end;


{ ---------------------------------------------------- }
{ --- ֥å·Υ                       --- }
{ ---------------------------------------------------- }

function TPuzzleBase.LineCount(x, y, dx, dy: Integer; layer: Integer): Integer;
var
  col, nextcol: Integer;
  score, ready: Integer;
begin
  score := 0;
  ready := 0;
  col := Field[x + (y * FIELD_WIDTH)].Color;
  if Field[x + (y * FIELD_WIDTH)].LineBlock = True then
    ready := ready + 1;
  repeat
    if layer = 2 then
    begin
      Field[x + (y * FIELD_WIDTH)].LineBlock := True;
      Field[x + (y * FIELD_WIDTH)].LineTimer := 15;
    end;
    x := x + dx;
    y := y + dy;
    if (x < 0) or (x >= FIELD_WIDTH) or (y < 1) or (y >= FIELD_HEIGHT) then
      nextcol := 0
    else
    begin
      if Field[x + (y * FIELD_WIDTH)] <> nil then
        nextcol := Field[x + (y * FIELD_WIDTH)].Color
      else
        nextcol := 0;
    end;
    score := score + 1;
    if col = nextcol then
    begin
      if Field[x + (y * FIELD_WIDTH)] <> nil then
        if Field[x + (y * FIELD_WIDTH)].LineBlock = True then
          ready := ready + 1;
    end;
  until((x < 0) or (x >= FIELD_WIDTH) or (y < 1) or (y >= FIELD_HEIGHT) or
        (col <> nextcol));
  x := x - dx;
  y := y - dy;
  { --- 쥤 }
  case layer of
    0:begin
        score := LineCount(x, y, -dx, -dy, 1);
      end;
    1:begin
        if (score >= LINE_LENGTH) and (score > ready) then
        begin
          score := LineCount(x, y, -dx, -dy, 2);
        end
        else
          score := 0;
      end;
    2: score := score - ready;
  end;
  LineCount := score;
end;


end.
