{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   sound.pp                                             }
{     ʰץ(SDL_mixer)                        }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: sound.pp,v 1.3 2002/08/10 03:05:14 rero2 Exp $ }
Unit  Sound;

{$MODE Delphi}


interface

Uses SDL, SDL_Audio, SDLmixer;


procedure  SoundInit;
procedure  SoundFree;
procedure  SoundMusic(req: Integer);
procedure  SoundMusicOneshot(req: Integer);
procedure  SoundSE(req: Integer);
procedure  SoundMusicStop;
procedure  SoundSEStop;

Const
  SoundListFile = 'sounddata.lst';
  BGMMAX = 32;
  SEMAX = 64;

Var
  { ----- BGM ȥå }
  SoundTrack: PMix_Music;
  BGMPool: Array [0..BGMMAX] of String;
  { ----- BGM ȥå }
  SEPool: Array [0..SEMAX] of PMix_Chunk;


implementation
{ -------------------------------------------------------------- }
{ ---                                                    }
{ -------------------------------------------------------------- }
uses  Sysutils;

Var
  { ----- ͭե饰 }
  SoundEnable: Boolean;
  { ----- ɥͥΥȥå }
  track: Integer;

{ ---------------------------------------- }
{ --- ɤνȥꥹɤ߹       }
{ ---------------------------------------- }
procedure  SoundInit;
var
  i, num: Integer;
  ret: Integer;
  FIN: Text;
  line: String;
  name: String;
begin
  track := 0;
  { ----- SDL_mixer Υץ }
  SoundEnable := True;
  ret := Mix_OpenAudio(22050, AUDIO_S16, 2, 1024);
  if ret <> 0 then
  begin
    SoundEnable := False;
    Exit;
  end;
  { ----- 󥯥ꥢ }
  for i := 0 to BGMMAX - 1 do
    BGMPool[i] := '';
  for i := 0 to SEMAX - 1 do
    SEPool[i] := nil;
  { ----- ɥꥹɤ߹ }
  AssignFile(FIN, SoundListFile);
  Reset(FIN);
  while eof(FIN) = False do
  begin
    Readln(FIN, line);
    if length(line) < 6 then Continue;
    if line[1] = ' ' then Continue;
    if line[1] = '#' then Continue;
    { --- BGM list }
    if line[1] = 'M' then
    begin
      num := (ord(line[2]) - ord('0')) * 100 + (ord(line[3]) - ord('0')) * 10 + (ord(line[4]) - ord('0'));
      i := length(line) - 1;
      name := RightStr(line, i - 4);
      BGMPool[num] := name;
    end;
    { --- SE list }
    if line[1] = 'S' then
    begin
      num := (ord(line[2]) - ord('0')) * 100 + (ord(line[3]) - ord('0')) * 10 + (ord(line[4]) - ord('0'));
      i := length(line) - 1;
      name := RightStr(line, i - 4);
      SEPool[num] := Mix_LoadWAV(PChar(name));
    end;
  end;
  CloseFile(FIN);
end;


{ ---------------------------------------- }
{ --- ɤβ                       }
{ ---------------------------------------- }
procedure  SoundFree;
var
  i: Integer;
begin
  if SoundEnable = False then Exit;
  { ----- ݻɤβ }
  if SoundTrack <> nil then
  begin
    Mix_HaltMusic;
    Mix_FreeMusic(SoundTrack);
    SoundTrack := nil;
  end;
  { ----- SEͥ }
  for i := 0 to 7 do
    Mix_HaltChannel(i);
  { ----- SE chank β }
  for i := 0 to SEMAX do
  begin
    if SEPool[i] <> nil then
    begin
      Mix_FreeChunk(SePool[i]);
      SePool[i] := nil;
    end;
  end;
  { ----- SDL_Mixer Υ }
  Mix_CloseAudio;
end;


{ ---------------------------------------- }
{ --- BGM Υꥯ                     }
{ ---------------------------------------- }
procedure  SoundMusic(req: Integer);
begin
  if SoundEnable = False then Exit;
  { --- }
  if req < 0 then Exit;
  if req >= BGMMAX then Exit;
  if BGMPool[req] = '' then Exit;
  { ----- ޤǤα }
  if SoundTrack <> nil then
  begin
    Mix_HaltMusic;
    Mix_FreeMusic(SoundTrack);
    SoundTrack := nil;
  end;
  { ----- BGM ճ }
  SoundTrack := Mix_LoadMUS(PChar(BGMPool[req]));
  if SoundTrack = nil then
  begin
    SoundTrack := nil;
    Exit;
  end;
  Mix_PlayMusic(SoundTrack, -1);
end;

{ ---------------------------------------- }
{ --- ֤ʤ BGM Υꥯ        }
{ ---------------------------------------- }
procedure  SoundMusicOneshot(req: Integer);
begin
  if SoundEnable = False then Exit;
  { --- }
  if req < 0 then Exit;
  if req >= BGMMAX then Exit;
  if BGMPool[req] = '' then Exit;
  { ----- ޤǤα }
  if SoundTrack <> nil then
  begin
    Mix_HaltMusic;
    Mix_FreeMusic(SoundTrack);
    SoundTrack := nil;
  end;
  { ----- BGM ճ }
  SoundTrack := Mix_LoadMUS(PChar(BGMPool[req]));
  if SoundTrack = nil then
  begin
    SoundTrack := nil;
    Exit;
  end;
  Mix_PlayMusic(SoundTrack, 1);
end;


{ ---------------------------------------- }
{ --- SE Υꥯ                      }
{ ---------------------------------------- }
procedure  SoundSE(req: Integer);
begin
  if SoundEnable = False then Exit;
  { --- }
  if req < 0 then Exit;
  if req >= BGMMAX then Exit;
  if SEPool[req] = nil then Exit;
  { ----- SE ȯ }
  Mix_PlayChannel(track, SEPool[req], 0);
  track := (track + 1) and 7;
end;

{ ---------------------------------------- }
{ --- BGM ȥå                   }
{ ---------------------------------------- }
procedure  SoundMusicStop;
begin
  if SoundEnable = False then Exit;
  { --- }
  Mix_HaltMusic;
end;

{ ---------------------------------------- }
{ --- SE                           }
{ ---------------------------------------- }
procedure  SoundSEStop;
var
  i: Integer;
begin
  if SoundEnable = False then Exit;
  { --- }
  { ----- SEͥ }
  for i := 0 to 7 do
    Mix_HaltChannel(i);
end;




end.